from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Permissions import p_manageRSSCollection
import AggregationTool
import RSSFeed
import RSSStory
import RSSCollection

import sys

this_module = sys.modules[__name__]

cmfaggregator_globals=globals()

registerDirectory('skins', globals())

contentClasses = ( RSSCollection.RSSCollection
                 , RSSFeed.RSSFeed
                 , RSSStory.RSSStory
                 )

contentConstructors = ( RSSCollection.addRSSCollection
                      , RSSFeed.addRSSFeed
                      , RSSStory.addRSSStory
                      )

factory_type_information = ( RSSCollection.factory_type_information
                           + RSSFeed.factory_type_information
                           + RSSStory.factory_type_information
                           )

bases = contentClasses

tools = (AggregationTool.AggregationTool, )

z_bases = utils.initializeBasesPhase1( bases, this_module )

z_tool_bases = utils.initializeBasesPhase1( tools, this_module )

def initialize( context ):
    
    utils.initializeBasesPhase2( z_bases, context )
    
    utils.initializeBasesPhase2( z_tool_bases, context )
    
    utils.ToolInit('CMFAggregator Tool', 
                   tools=tools,
                   product_name='CMFAggregator', 
                   icon='tool.gif',
                  ).initialize( context )
    
    utils.ContentInit( 'CMFAggregator Content'
                     , content_types=contentClasses
                     , permission=p_manageRSSCollection
                     , extra_constructors=contentConstructors
                     , fti=factory_type_information
                     ).initialize( context )
