import xmlrpclib
import socket

#Mapping network -> proxy
net_proxy_mapping = {'192.168.60.0': '192.168.60.193:8800',
                     '192.168.50.0': '192.168.50.1:8080'}
def getProxy():
    localIPs = socket.gethostbyname_ex(socket.gethostname())[2]
    localIPs = map(lambda x: x.split('.'), localIPs)
    localIPs = filter(lambda x: len(x) == 4, localIPs)
    networks = map(lambda x: '.'.join(x[:3] + ['0']), localIPs)

    if '203' in map(lambda x: x[:3], networks): # ISP
        return
    if '192.168.100.0' in networks: # ITprog
        return

    for network in net_proxy_mapping.keys():
        if network in networks: 
            proxy = net_proxy_mapping[network]
            return proxy

Proxy = getProxy()
if not getattr(xmlrpclib.Transport, '__patched__', 0):
    class Transport(xmlrpclib.Transport):
        __patched__ = 1
        def make_connection(self, host):
            import httplib
            if not Proxy:
                return httplib.HTTP(host)
            else:
                self.RealHost = host
                return httplib.HTTP(Proxy)
        def send_request(self, connection, handler, request_body):
            if not Proxy:
                connection.putrequest('POST', handler)
            else:
                connection.putrequest('POST', 'http://' + self.RealHost + handler)

    # "Monkey" patch
    del xmlrpclib.Transport
    xmlrpclib.Transport = Transport
